//************************************************************************
//*                     BipCalc for BipGDI  VERSION 1.0                  *
//*----------------------------------------------------------------------*
//*                                                                      *
//* Compilation options :                                                *
//* add comctl32.lib in Project/Settings/Link/Objet library modules      *
//*                                                                      *
//*    Require : BipGDI Win V0.9.3                                       *
//*    Require : BipDate Win V0.9.1                                      *
//*    Require : BipNum Win V0.9.1                                       *
//*                                                         Basset P.    *
//************************************************************************

#include <windows.h>
#include <string>


// Include for Bip
#include "BipGDI.h"


	using namespace std;



//-------------------------------------------------------------
//!        Global variables                                   !
//-------------------------------------------------------------
	int iOldValue;
	string sCurrentNum;
	string sOperator;



//-------------------------------------------------------------
//!        Display number on calculator form                  !
//-------------------------------------------------------------
int Display (const string sValue)
{
	int iError;
	string sDisplay;

	// display "0" if value is null
	if (sValue == "")
		sDisplay = "0";
	else
		sDisplay = sValue;

	// modify display field
	iError = BG_FormItemModify ("calc", "display", BG_PRM_VALUE, sDisplay);

	return iError;
}



//-------------------------------------------------------------
//!        Procedure for calc form                            !
//-------------------------------------------------------------
int Form_Calc_Proc (const string sBGFormName, const string sBGItemName, const string sBGMessage,
				HWND hBGCurWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	int iError;
	int iNum;
	string sNewNum;
	string sString;


	// one button is clic
	if (sBGMessage == BG_MSG_ITEMCLIC)
	{
		// numeric button is press
		if (sBGItemName >= "0" && sBGItemName <= "9")
		{
			// limit number to integer limit
			sNewNum = sCurrentNum + sBGItemName;
			iNum = BG_StringToInt (sNewNum);
			sString = BG_IntToString (iNum);
			if (sString == sNewNum)
				sCurrentNum = sNewNum;

			// reset old value
			if (sOperator == "=")
				iOldValue = BG_StringToInt (sCurrentNum);

			// modify display
			iError = Display (sCurrentNum);

			return 0;
		}

		// clear button is press
		if (sBGItemName == "C/CE")
		{
			// reset calculator variables
			iOldValue = 0;
			sCurrentNum = "";
			sOperator = "";

			// modify display
			iError = Display ("0");

			return 0;
		}

		// operator button is press
		if (sBGItemName == "+" || sBGItemName == "-" || sBGItemName == "*"||
		    sBGItemName == "=")
		{
			if (sOperator != "")
			{
				// compute new value
				iNum = BG_StringToInt (sCurrentNum);

				if (sOperator == "+")
					iOldValue += iNum;
				else if (sOperator == "-")
					iOldValue -= iNum;
				else if (sOperator == "*")
					iOldValue *= iNum;

				// save result
				sNewNum = BG_IntToString (iOldValue);

				// modify display
				iError = Display (sNewNum);
			}
			else
				iOldValue = BG_StringToInt (sCurrentNum);

			// reset current number
			sCurrentNum = "";

			// save current operator
			sOperator = sBGItemName;

			return 0;
		}
	}

	return 0;
}



//-------------------------------------------------------------
//!        Display calculator form                            !
//-------------------------------------------------------------
void Form_Calc (void)
{
	int iError;
	int iItem;
	int iLine;
	int iMargin;

	// initialize item number
	iItem = 1;

	// initialize button line number
	iLine = 0;

	// initialize margin
	iMargin = 32;


	// create title
	iError = BG_FormItemAdd ("calc", "title", BG_ITEM_STATIC, iItem++, 5, 5, 230, 30,
				"value=Integer Calculator;txhpos=right;ftname=Arial;ftsize=8;txcol=blue");

	// create display item
	iError = BG_FormItemAdd ("calc", "display", BG_ITEM_STATIC, iItem++, 5, (iLine * 40) + 20, 230, 30,
				"value=0;txhpos=right;txvpos=center;ftname=Courier New;ftsize=16;ftbold=true;brdstyle=3DIN;bkcol=white");

	iLine++;

	// create C/CE button
	iError = BG_FormItemAdd ("calc", "C/CE", BG_ITEM_BUTTON, iItem++, iMargin + 90, (iLine * 40) + 20, 80, 35,
				"bkcol=green");

	iLine++;

	// create first numeric line
	iError = BG_FormItemAdd ("calc", "7", BG_ITEM_BUTTON, iItem++, iMargin, (iLine * 40) + 30, 35, 35);
	iError = BG_FormItemAdd ("calc", "8", BG_ITEM_BUTTON, iItem++, iMargin + 45, (iLine * 40) + 30, 35, 35);
	iError = BG_FormItemAdd ("calc", "9", BG_ITEM_BUTTON, iItem++, iMargin + 90, (iLine * 40) + 30, 35, 35);
	iError = BG_FormItemAdd ("calc", "*", BG_ITEM_BUTTON, iItem++, iMargin + 135, (iLine * 40) + 30, 35, 35, "bkcol=cyan");

	iLine++;

	// create second numeric line
	iError = BG_FormItemAdd ("calc", "4", BG_ITEM_BUTTON, iItem++, iMargin, (iLine * 40) + 35, 35, 35);
	iError = BG_FormItemAdd ("calc", "5", BG_ITEM_BUTTON, iItem++, iMargin + 45, (iLine * 40) + 35, 35, 35);
	iError = BG_FormItemAdd ("calc", "6", BG_ITEM_BUTTON, iItem++, iMargin + 90, (iLine * 40) + 35, 35, 35);
	iError = BG_FormItemAdd ("calc", "-", BG_ITEM_BUTTON, iItem++, iMargin + 135, (iLine * 40) + 35, 35, 35, "bkcol=cyan");

	iLine++;

	// create third numeric line
	iError = BG_FormItemAdd ("calc", "1", BG_ITEM_BUTTON, iItem++, iMargin, (iLine * 40) + 40, 35, 35);
	iError = BG_FormItemAdd ("calc", "2", BG_ITEM_BUTTON, iItem++, iMargin + 45, (iLine * 40) + 40, 35, 35);
	iError = BG_FormItemAdd ("calc", "3", BG_ITEM_BUTTON, iItem++, iMargin + 90, (iLine * 40) + 40, 35, 35);
	iError = BG_FormItemAdd ("calc", "+", BG_ITEM_BUTTON, iItem++, iMargin + 135, (iLine * 40) + 40, 35, 35, "bkcol=cyan");

	iLine++;

	// create fourth numeric line
	iError = BG_FormItemAdd ("calc", "0", BG_ITEM_BUTTON, iItem++, iMargin, (iLine * 40) + 50, 80, 35);
	iError = BG_FormItemAdd ("calc", "=", BG_ITEM_BUTTON, iItem++, iMargin + 90, (iLine * 40) + 50, 80, 35, "bkcol=red;txcol=white");


	// display form
	iError = BG_FormCreate ("calc", "bkcol=lightgrey;edge=false;stbar=false", 0, 0, 250, 350, Form_Calc_Proc);
	if (iError != 0)
		BG_ErrorDisplay (iError);

}



//-------------------------------------------------------------
//!    Procedure for main window                              !
//-------------------------------------------------------------
LRESULT CALLBACK WndProc (HWND hBGCurWnd, UINT message, WPARAM wParam, LPARAM lParam)
{

	int iError;


	// automatic message treatment
	iError = BG_WindowMessageAuto (message, wParam);

	return DefWindowProc (hBGCurWnd, message, wParam, lParam);

}



//-------------------------------------------------------------
//!        BEGINING OF PROGRAM                                !
//-------------------------------------------------------------
int APIENTRY WinMain (HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine,
					  int nCmdShow)
{
	int iError;


	// initialize value
	iOldValue = 0;
	sCurrentNum = "";
	sOperator = "";

	// create main window
	iError = BG_WindowMainCreate ("Main", nCmdShow, WndProc, "name=BipCalc v1.0", 0, 0, 250, 350);
	if (iError != 0)
		return iError;

	// create modeless form
	Form_Calc ();


	// enter message loop
	return BG_MessageLoop();

}
